Index: bootscripts/ChangeLog
===================================================================
--- bootscripts/ChangeLog	(revision 43c2ecf0b898e8dfaca243df6946522b5d49cda5)
+++ bootscripts/ChangeLog	(revision 0cda8984a835f37a573c0e2eb31676ff52773d16)
@@ -1,20 +1,36 @@
-2011-05-31	DJ Lucas <dj@linuxfromscratch.org>
+2011-07-14  Bruce Dubbs <bdubbs@linuxfromscratch.org>
+   * Major rewrite of all LFS scripts
+   ** Move ifup/ifdown to /sbin
+   ** Move functions and network services to /lib/boot
+   ** Remove contrib directory
+   ** Move all READ commands to functions and allow the user to specify
+      HEADLESS=1 to skip READ commands
+   ** Add /etc/sysconfig/init_params for adding environmental parameters
+      to all functions used in bootscripts
+   ** Move network configuration to /etc/sysconfig/ifconfig.*.  The 
+      ifconfig files can have any extention.  Use IFACE parameter to 
+      specify the target network interface within the configuration file.
+   ** Adds an optional parameter, SKIPTMPCLEAN, to skip the removal of 
+      files in /tmp at bootup.  Specify the variable in 
+      /etc/sysconfig/init_params.
+
+2011-05-31  DJ Lucas <dj@linuxfromscratch.org>
    * lfs/init.d/udev: Add multiple udev triggers for both subsystems and
      devices per upstream recommendation.
 
-2011-04-19	Bruce Dubbs <bdubbs@linuxfromscratch.org>
+2011-04-19  Bruce Dubbs <bdubbs@linuxfromscratch.org>
    * lfs/init.d/mountvirtfs: Add creation of /run/{var,lock,shm}.
    * lfs/init.d/udev: Add /dev/shm -> /run/shm symlink.
 
-2011-04-18	Bruce Dubbs <bdubbs@linuxfromscratch.org>
+2011-04-18  Bruce Dubbs <bdubbs@linuxfromscratch.org>
    * lfs/init.d/mountvirtfs: Change name from mountkernfs to mountvirtfs.
      Add mounting of /run filesystem.
 
-2010-05-29	Matt Burgess <matthew@linuxfromscratch.org>
+2010-05-29  Matt Burgess <matthew@linuxfromscratch.org>
    * lfs/init.d/udev: Only copy /lib/udev/devices/null, as Udev >= 155 copies
      devices from /lib/udev/devices to /dev itself.  Udevd still needs /dev/null
      present before starting up though.
 
-2010-04-20	Bryan Kadzban <bryan@linuxfromscratch.org>
+2010-04-20  Bryan Kadzban <bryan@linuxfromscratch.org>
    * lfs/init.d/udev, lfs/init.d/udev_retry: Add --action=add, to handle udev
    version 152 and newer, which send "change" events by default in udevtrigger
Index: bootscripts/Makefile
===================================================================
--- bootscripts/Makefile	(revision 43c2ecf0b898e8dfaca243df6946522b5d49cda5)
+++ bootscripts/Makefile	(revision 0cda8984a835f37a573c0e2eb31676ff52773d16)
@@ -1,4 +1,5 @@
 ETCDIR=/etc
 EXTDIR=${DESTDIR}${ETCDIR}
+LIBDIR=${DESTDIR}/lib/boot
 MODE=754
 DIRMODE=755
@@ -18,12 +19,11 @@
 	install -d -m ${DIRMODE} ${EXTDIR}/rc.d/init.d
 	install -d -m ${DIRMODE} ${EXTDIR}/sysconfig
+	install -d -m ${DIRMODE} ${LIBDIR}
 
-create-service-dir:
-	install -d -m ${DIRMODE} ${EXTDIR}/sysconfig/network-devices/services
-
-install: create-dirs create-service-dir
+install: create-dirs 
 	install -m ${MODE} lfs/init.d/checkfs       ${EXTDIR}/rc.d/init.d/
 	install -m ${MODE} lfs/init.d/cleanfs       ${EXTDIR}/rc.d/init.d/
 	install -m ${CONFMODE} lfs/init.d/functions ${EXTDIR}/rc.d/init.d/
+	install -m ${CONFMODE} lfs/init.d/functions ${LIBDIR}
 	install -m ${MODE} lfs/init.d/halt          ${EXTDIR}/rc.d/init.d/
 	install -m ${MODE} lfs/init.d/console       ${EXTDIR}/rc.d/init.d/
@@ -38,5 +38,5 @@
 	install -m ${MODE} lfs/init.d/sendsignals   ${EXTDIR}/rc.d/init.d/
 	install -m ${MODE} lfs/init.d/setclock      ${EXTDIR}/rc.d/init.d/
-	install -m ${MODE} lfs/init.d/sysklogd	    ${EXTDIR}/rc.d/init.d/
+	install -m ${MODE} lfs/init.d/sysklogd      ${EXTDIR}/rc.d/init.d/
 	install -m ${MODE} lfs/init.d/swap          ${EXTDIR}/rc.d/init.d/
 	install -m ${MODE} lfs/init.d/sysctl        ${EXTDIR}/rc.d/init.d/
@@ -45,5 +45,5 @@
 	install -m ${MODE} lfs/init.d/udev_retry    ${EXTDIR}/rc.d/init.d/
 	ln -sf ../init.d/network     ${EXTDIR}/rc.d/rc0.d/K80network
-	ln -sf ../init.d/sysklogd   ${EXTDIR}/rc.d/rc0.d/K90sysklogd
+	ln -sf ../init.d/sysklogd    ${EXTDIR}/rc.d/rc0.d/K90sysklogd
 	ln -sf ../init.d/sendsignals ${EXTDIR}/rc.d/rc0.d/S60sendsignals
 	ln -sf ../init.d/mountfs     ${EXTDIR}/rc.d/rc0.d/S70mountfs
@@ -52,15 +52,15 @@
 	ln -sf ../init.d/halt        ${EXTDIR}/rc.d/rc0.d/S99halt
 	ln -sf ../init.d/network     ${EXTDIR}/rc.d/rc1.d/K80network
-	ln -sf ../init.d/sysklogd   ${EXTDIR}/rc.d/rc1.d/K90sysklogd
+	ln -sf ../init.d/sysklogd    ${EXTDIR}/rc.d/rc1.d/K90sysklogd
 	ln -sf ../init.d/network     ${EXTDIR}/rc.d/rc2.d/K80network
-	ln -sf ../init.d/sysklogd   ${EXTDIR}/rc.d/rc2.d/K90sysklogd
-	ln -sf ../init.d/sysklogd   ${EXTDIR}/rc.d/rc3.d/S10sysklogd
+	ln -sf ../init.d/sysklogd    ${EXTDIR}/rc.d/rc2.d/K90sysklogd
+	ln -sf ../init.d/sysklogd    ${EXTDIR}/rc.d/rc3.d/S10sysklogd
 	ln -sf ../init.d/network     ${EXTDIR}/rc.d/rc3.d/S20network
-	ln -sf ../init.d/sysklogd   ${EXTDIR}/rc.d/rc4.d/S10sysklogd
+	ln -sf ../init.d/sysklogd    ${EXTDIR}/rc.d/rc4.d/S10sysklogd
 	ln -sf ../init.d/network     ${EXTDIR}/rc.d/rc4.d/S20network
-	ln -sf ../init.d/sysklogd   ${EXTDIR}/rc.d/rc5.d/S10sysklogd
+	ln -sf ../init.d/sysklogd    ${EXTDIR}/rc.d/rc5.d/S10sysklogd
 	ln -sf ../init.d/network     ${EXTDIR}/rc.d/rc5.d/S20network
 	ln -sf ../init.d/network     ${EXTDIR}/rc.d/rc6.d/K80network
-	ln -sf ../init.d/sysklogd   ${EXTDIR}/rc.d/rc6.d/K90sysklogd
+	ln -sf ../init.d/sysklogd    ${EXTDIR}/rc.d/rc6.d/K90sysklogd
 	ln -sf ../init.d/sendsignals ${EXTDIR}/rc.d/rc6.d/S60sendsignals
 	ln -sf ../init.d/mountfs     ${EXTDIR}/rc.d/rc6.d/S70mountfs
@@ -80,11 +80,17 @@
 	ln -sf ../init.d/localnet    ${EXTDIR}/rc.d/rcsysinit.d/S80localnet
 	ln -sf ../init.d/sysctl      ${EXTDIR}/rc.d/rcsysinit.d/S90sysctl
-	if [ ! -f ${EXTDIR}/sysconfig/createfiles ]; then install -m ${CONFMODE} lfs/sysconfig/createfiles ${EXTDIR}/sysconfig/; fi
-	if [ ! -f ${EXTDIR}/sysconfig/modules     ]; then install -m ${CONFMODE} lfs/sysconfig/modules     ${EXTDIR}/sysconfig/; fi
-	if [ ! -f ${EXTDIR}/sysconfig/rc          ]; then install -m ${CONFMODE} lfs/sysconfig/rc          ${EXTDIR}/sysconfig/; fi
-	install                   -m ${MODE} lfs/sysconfig/network-devices/ifup   ${EXTDIR}/sysconfig/network-devices/
-	install                   -m ${MODE} lfs/sysconfig/network-devices/ifdown ${EXTDIR}/sysconfig/network-devices/
-	install                   -m ${MODE} lfs/sysconfig/network-devices/services/ipv4-static       ${EXTDIR}/sysconfig/network-devices/services/
-	install                   -m ${MODE} lfs/sysconfig/network-devices/services/ipv4-static-route ${EXTDIR}/sysconfig/network-devices/services/
+	if [ ! -f ${EXTDIR}/sysconfig/createfiles ]; then \
+     install -m ${CONFMODE} lfs/sysconfig/createfiles ${EXTDIR}/sysconfig/ ;\
+   fi
+	if [ ! -f ${EXTDIR}/sysconfig/modules     ]; then \
+     install -m ${CONFMODE} lfs/sysconfig/modules     ${EXTDIR}/sysconfig/ ;\
+   fi
+	if [ ! -f ${EXTDIR}/sysconfig/rc          ]; then \
+     install -m ${CONFMODE} lfs/sysconfig/rc          ${EXTDIR}/sysconfig/ ;\
+   fi
+	install -m ${MODE} lfs/sysconfig/network-devices/ifup   /sbin
+	install -m ${MODE} lfs/sysconfig/network-devices/ifdown /sbin
+	install -m ${MODE} lfs/sysconfig/network-devices/services/ipv4-static       ${LIBDIR}
+	install -m ${MODE} lfs/sysconfig/network-devices/services/ipv4-static-route ${LIBDIR}
 
 install-consolelog: create-dirs
@@ -92,14 +98,9 @@
 	ln -sf ../init.d/consolelog  ${EXTDIR}/rc.d/rcsysinit.d/S00consolelog
 
-install-lsb-compliant:
-	make -C contrib/lsb
-
-install-service-mtu: create-service-dir
-	install -m ${MODE} contrib/sysconfig/network-devices/services/mtu ${EXTDIR}/sysconfig/network-devices/services
-
-minimal: create-dirs create-service-dir
+minimal: create-dirs 
 	install -m ${MODE} lfs/init.d/checkfs       ${EXTDIR}/rc.d/init.d/
 	install -m ${MODE} lfs/init.d/cleanfs       ${EXTDIR}/rc.d/init.d/
 	install -m ${CONFMODE} lfs/init.d/functions ${EXTDIR}/rc.d/init.d/
+	install -m ${CONFMODE} lfs/init.d/functions ${LIBDIR}
 	install -m ${MODE} lfs/init.d/halt          ${EXTDIR}/rc.d/init.d/
 	install -m ${MODE} lfs/init.d/localnet      ${EXTDIR}/rc.d/init.d/
@@ -126,7 +127,8 @@
 	ln -sf ../init.d/mountfs     ${EXTDIR}/rc.d/rcsysinit.d/S40mountfs
 	ln -sf ../init.d/cleanfs     ${EXTDIR}/rc.d/rcsysinit.d/S45cleanfs
-	if [ ! -f ${EXTDIR}/sysconfig/rc          ]; then install -m ${CONFMODE} lfs/sysconfig/rc          ${EXTDIR}/sysconfig/; fi
+	if [ ! -f ${EXTDIR}/sysconfig/rc          ]; then \
+      install -m ${CONFMODE} lfs/sysconfig/rc ${EXTDIR}/sysconfig/; \
+   fi
 
-.PHONY: all create-dirs create-service-dir \
-	install install-service-mtu
+.PHONY: all create-dirs install 
 
Index: bootscripts/README
===================================================================
--- bootscripts/README	(revision 43c2ecf0b898e8dfaca243df6946522b5d49cda5)
+++ bootscripts/README	(revision 0cda8984a835f37a573c0e2eb31676ff52773d16)
@@ -1,76 +1,79 @@
 Network Configuration:
-	Script Files:
-		rc.d/init.d/network
-		sysconfig/network-devices/ifup
-		sysconfig/network-devices/ifdown
-		sysconfig/network-devices/services/*
+   Script Files:
+      /etc/rc.d/init.d/network
+      /sbin/ifup
+      /sbin/ifdown
+      /lib/boot/*/*
 
-	Configuration Files:
-		sysconfig/network-devices/ifconfig.*/*
-		Note: ifconfig.* could be either a file or directory,
-		      but the filename extension must be the same name
-		      as the network interface you wish it to belong to.
-		      The files within the directory will be processed
-		      in alphanumerical order on boot, and reversed on
-		      shutdown.
-		- SERVICE: which script to run in services directory.
-		- ONBOOT: if set to yes, this interface will be started on
-		          bootup, and stopped on shutdown
+   Configuration Files:
+      /etc/sysconfig/ifconfig.*
+      Note: ifconfig.* could be either a file or directory,
+            but the filename extension must be the same name
+            as the network interface you wish it to belong to.
+            The files within the directory will be processed
+            in alphanumerical order on boot, and reversed on
+            shutdown.
+      - IFACE: the interface that is being configured (e.g. eth0)
+      - SERVICE: which script to run in services directory.
+      - ONBOOT: if set to yes, this interface will be started on
+                bootup, and stopped on shutdown
 
-		sysconfig/network
-		- HOSTNAME: Value of the system's hostname
+      /etc/sysconfig/network
+      - HOSTNAME: Value of the system's hostname
 
-	Additional Configuration:
-		sysconfig/network-devices/ifconfig.*
-		ipv4-static:
-		- IP: static IP Address
-		- GATEWAY: Specifies the IP Address of the gateway server
-		- PREFIX: CIDR prefix of IP Address, defaults to 24 if not set
-		- PEER: IP Address of peer (for point-to-point connections and tunnels)
-		- BROADCAST: broadcast address
-		ipv4-static-route:
-		- TYPE: network (default type if not specified), default, host or
-		  unreachable
-		- IP: IP Address of target (for network, host and unreachable)
-		- PREFIX: CIDR prefix of target (for network, host and unreachable)
-		- GATEWAY: IP Address of gateway to reach target (for network and default)
+   Additional Configuration:
+      ipv4-static:
+      - IP: static IP Address
+      - GATEWAY: Specifies the IP Address of the gateway server
+      - PREFIX: CIDR prefix of IP Address, defaults to 24 if not set
+      - PEER: IP Address of peer (for point-to-point connections and tunnels)
+      - BROADCAST: broadcast address
+
+      ipv4-static-route:
+      - TYPE: network (default type if not specified), default, host or
+        unreachable
+      - IP: IP Address of target (for network, host and unreachable)
+      - PREFIX: CIDR prefix of target (for network, host and unreachable)
+      - GATEWAY: IP Address of gateway to reach target (for network and default)
 
 
 SetClock configuration:
-	Script Files:
-		rc.d/init.d/setclock
+   Script Files:
+      /etc/rc.d/init.d/setclock
+      - SKIPTMPCLEAN: skips cleaning of /tmp directory
 
-	Configuration Files:
-		sysconfig/clock
-		- UTC: 1 assumes hwclock is in UTC
-		       0 assumes hwclock is in local time
-		- CLOCKPARAMS: any additional options to be passed to hwclock
+   Configuration Files:
+      /etc/sysconfig/clock
+      - UTC: 1 assumes hwclock is in UTC
+             0 assumes hwclock is in local time
+      - CLOCKPARAMS: any additional options to be passed to hwclock
 
 CleanFS configuration:
-	Script Files:
-		rc.d/init.d/cleanfs
+   Script Files:
+      /etc/rc.d/init.d/cleanfs
 
-	Configuration Files:
-		/etc/sysconfig/createfiles
-		Each line is parsed, using space as a deliminator.
-		[NAME] [TYPE] [PERMISSIONS] [USER] [GROUP]
-		The below fields are currently only used on dev type.
-		([DEV TYPE] [MAJOR#] [MINOR#])
-		Name:
-			File/Directory/Device name
-		Type:
-			dir: creates a directory
-			file: creates a file
-			dev: creates a device
-		Permissions:
-			chmod the created file
-		User/Group:
-			chown the created file/dir to this user/group
-		Dev Type:
-			char:  character [needs MAJOR#, MINOR#]
-			block: block [needs MAJOR#, MINOR#]
-			pipe:  pipe
-		Major#:
-			Used by character and block devices.
-		Minor#:
-			Used by character and block devices.
+   Configuration Files:
+      /etc/sysconfig/createfiles
+      Each line is parsed, using space as a deliminator.
+      [NAME] [TYPE] [PERMISSIONS] [USER] [GROUP]
+      The below fields are currently only used on dev type.
+      ([DEV TYPE] [MAJOR#] [MINOR#])
+      Name:
+         File/Directory/Device name
+      Type:
+         dir: creates a directory
+         file: creates a file
+         dev: creates a device
+      Permissions:
+         chmod the created file
+      User/Group:
+         chown the created file/dir to this user/group
+      Dev Type:
+         char:  character [needs MAJOR#, MINOR#]
+         block: block [needs MAJOR#, MINOR#]
+         pipe:  pipe
+      Major#:
+         Used by character and block devices.
+      Minor#:
+         Used by character and block devices.
+
Index: bootscripts/lfs/init.d/checkfs
===================================================================
--- bootscripts/lfs/init.d/checkfs	(revision 43c2ecf0b898e8dfaca243df6946522b5d49cda5)
+++ bootscripts/lfs/init.d/checkfs	(revision 0cda8984a835f37a573c0e2eb31676ff52773d16)
@@ -1,5 +1,5 @@
 #!/bin/sh
 ########################################################################
-# Begin $rc_base/init.d/checkfs
+# Begin checkfs
 #
 # Description : File System Check
@@ -7,8 +7,7 @@
 # Authors     : Gerard Beekmans - gerard@linuxfromscratch.org
 #               A. Luebke - luebke@users.sourceforge.net
+# Update      : Bruce Dubbs - bdubbs@linuxfromscratch.org
 #
-# Version     : 00.00
-#
-# Notes       :
+# Version     : LFS 7.0
 #
 # Based on checkfs script from LFS-3.1 and earlier.
@@ -26,106 +25,118 @@
 #########################################################################
 
-. /etc/sysconfig/rc
-. ${rc_functions}
+### BEGIN INIT INFO
+# Provides:            checkfs
+# Required-Start:      udev swap $time
+# Should-Start:
+# Required-Stop:
+# Should-Stop:
+# Default-Start:       S
+# Default-Stop:
+# Short-Description:   Checks local filesystems before mounting.
+# Description:         Checks local filesystmes before mounting.
+# X-LFS-Provided-By:   LFS
+### END INIT INFO
+
+. /lib/boot/functions
 
 case "${1}" in
-	start)
-		if [ -f /fastboot ]; then
-			boot_mesg -n "/fastboot found, will not perform" ${INFO}
-			boot_mesg " file system checks as requested."
-			echo_ok
-			exit 0
-		fi
+   start)
+      if [ -f /fastboot ]; then
+         boot_mesg -n "/fastboot found, will not perform" ${INFO}
+         boot_mesg " file system checks as requested."
+         echo_ok
+         exit 0
+      fi
 
-		boot_mesg "Mounting root file system in read-only mode..."
-		mount -n -o remount,ro / >/dev/null
-		evaluate_retval
+      boot_mesg "Mounting root file system in read-only mode..."
+      mount -n -o remount,ro / >/dev/null
+      evaluate_retval
 
-		if [ ${?} != 0 ]; then
-			echo_failure
-			boot_mesg -n "FAILURE:\n\nCannot check root" ${FAILURE}
-			boot_mesg -n " filesystem because it could not be mounted"
-			boot_mesg -n " in read-only mode.\n\nAfter you"
-			boot_mesg -n " press Enter, this system will be"
-			boot_mesg -n " halted and powered off."
-			boot_mesg -n "\n\nPress enter to continue..." ${INFO}
-			boot_mesg "" ${NORMAL}
-			read ENTER
-			${rc_base}/init.d/halt stop
-		fi
+      if [ ${?} != 0 ]; then
+         echo_failure
+         boot_mesg -n "FAILURE:\n\nCannot check root" ${FAILURE}
+         boot_mesg -n " filesystem because it could not be mounted"
+         boot_mesg -n " in read-only mode.\n\nAfter you"
+         boot_mesg -n " press Enter, this system will be"
+         boot_mesg -n " halted and powered off."
+         boot_mesg -n "\n\nPress enter to continue..." ${INFO}
+         boot_mesg "" ${NORMAL}
+         wait_for_user
+         /etc/rc.d/init.d/halt stop
+      fi
 
-		if [ -f /forcefsck ]; then
-			boot_mesg -n "/forcefsck found, forcing file" ${INFO}
-			boot_mesg " system checks as requested."
-			echo_ok
-			options="-f"
-		else
-			options=""
-		fi
+      if [ -f /forcefsck ]; then
+         boot_mesg -n "/forcefsck found, forcing file" ${INFO}
+         boot_mesg " system checks as requested."
+         echo_ok
+         options="-f"
+      else
+         options=""
+      fi
 
-		boot_mesg "Checking file systems..."
-		# Note: -a option used to be -p; but this fails e.g.
-		# on fsck.minix
-		fsck ${options} -a -A -C -T
-		error_value=${?}
+      boot_mesg "Checking file systems..."
+      # Note: -a option used to be -p; but this fails e.g.
+      # on fsck.minix
+      fsck ${options} -a -A -C -T
+      error_value=${?}
 
-		if [ "${error_value}" = 0 ]; then
-			echo_ok
-		fi
+      if [ "${error_value}" = 0 ]; then
+         echo_ok
+      fi
 
-		if [ "${error_value}" = 1 ]; then
-			echo_warning
-			boot_mesg -n "WARNING:\n\nFile system errors" ${WARNING}
-			boot_mesg -n " were found and have been corrected."
-			boot_mesg -n "  You may want to double-check that"
-			boot_mesg -n " everything was fixed properly."
-			boot_mesg "" ${NORMAL}
-		fi
+      if [ "${error_value}" = 1 ]; then
+         echo_warning
+         boot_mesg -n "WARNING:\n\nFile system errors" ${WARNING}
+         boot_mesg -n " were found and have been corrected. "
+         boot_mesg -n " You may want to double-check that"
+         boot_mesg -n " everything was fixed properly."
+         boot_mesg "" ${NORMAL}
+      fi
 
-		if [ "${error_value}" = 2 -o "${error_value}" = 3 ]; then
-			echo_warning
-			boot_mesg -n "WARNING:\n\nFile system errors" ${WARNING}
-			boot_mesg -n " were found and have been been"
-			boot_mesg -n " corrected, but the nature of the"
-			boot_mesg -n " errors require this system to be"
-			boot_mesg -n " rebooted.\n\nAfter you press enter,"
-			boot_mesg -n " this system will be rebooted"
-			boot_mesg -n "\n\nPress Enter to continue..." ${INFO}
-			boot_mesg "" ${NORMAL}
-			read ENTER
-			reboot -f
-		fi
+      if [ "${error_value}" = 2 -o "${error_value}" = 3 ]; then
+         echo_warning
+         boot_mesg -n "WARNING:\n\nFile system errors" ${WARNING}
+         boot_mesg -n " were found and have been been"
+         boot_mesg -n " corrected, but the nature of the"
+         boot_mesg -n " errors require this system to be"
+         boot_mesg -n " rebooted.\n\nAfter you press enter,"
+         boot_mesg -n " this system will be rebooted"
+         boot_mesg -n "\n\nPress Enter to continue..." ${INFO}
+         boot_mesg "" ${NORMAL}
+         wait_for_user
+         reboot -f
+      fi
 
-		if [ "${error_value}" -gt 3 -a "${error_value}" -lt 16 ]; then
-			echo_failure
-			boot_mesg -n "FAILURE:\n\nFile system errors" ${FAILURE}
-			boot_mesg -n " were encountered that could not be"
-			boot_mesg -n " fixed automatically.  This system"
-			boot_mesg -n " cannot continue to boot and will"
-			boot_mesg -n " therefore be halted until those"
-			boot_mesg -n " errors are fixed manually by a"
-			boot_mesg -n " System Administrator.\n\nAfter you"
-			boot_mesg -n " press Enter, this system will be"
-			boot_mesg -n " halted and powered off."
-			boot_mesg -n "\n\nPress Enter to continue..." ${INFO}
-			boot_mesg "" ${NORMAL}
-			read ENTER
-		  ${rc_base}/init.d/halt stop
-		fi
+      if [ "${error_value}" -gt 3 -a "${error_value}" -lt 16 ]; then
+         echo_failure
+         boot_mesg -n "FAILURE:\n\nFile system errors" ${FAILURE}
+         boot_mesg -n " were encountered that could not be"
+         boot_mesg -n " fixed automatically.  This system"
+         boot_mesg -n " cannot continue to boot and will"
+         boot_mesg -n " therefore be halted until those"
+         boot_mesg -n " errors are fixed manually by a"
+         boot_mesg -n " System Administrator.\n\nAfter you"
+         boot_mesg -n " press Enter, this system will be"
+         boot_mesg -n " halted and powered off."
+         boot_mesg -n "\n\nPress Enter to continue..." ${INFO}
+         boot_mesg "" ${NORMAL}
+         wait_for_user
+        /etc/rc.d/init.d/halt stop
+      fi
 
-		if [ "${error_value}" -ge 16 ]; then
-			echo_failure
-			boot_mesg -n "FAILURE:\n\nUnexpected Failure" ${FAILURE}
-			boot_mesg -n " running fsck.  Exited with error"
-			boot_mesg -n " code: ${error_value}."
-			boot_mesg "" ${NORMAL}
-			exit ${error_value}
-		fi
-		;;
-	*)
-		echo "Usage: ${0} {start}"
-		exit 1
-		;;
+      if [ "${error_value}" -ge 16 ]; then
+         echo_failure
+         boot_mesg -n "FAILURE:\n\nUnexpected Failure" ${FAILURE}
+         boot_mesg -n " running fsck.  Exited with error"
+         boot_mesg -n " code: ${error_value}."
+         boot_mesg "" ${NORMAL}
+         exit ${error_value}
+      fi
+      ;;
+   *)
+      echo "Usage: ${0} {start}"
+      exit 1
+      ;;
 esac
 
-# End $rc_base/init.d/checkfs
+# End checkfs
Index: bootscripts/lfs/init.d/cleanfs
===================================================================
--- bootscripts/lfs/init.d/cleanfs	(revision 43c2ecf0b898e8dfaca243df6946522b5d49cda5)
+++ bootscripts/lfs/init.d/cleanfs	(revision 0cda8984a835f37a573c0e2eb31676ff52773d16)
@@ -1,18 +1,31 @@
 #!/bin/sh
 ########################################################################
-# Begin $rc_base/init.d/cleanfs
+# Begin cleanfs
 #
 # Description : Clean file system
 #
 # Authors     : Gerard Beekmans - gerard@linuxfromscratch.org
+# Update      : Bruce Dubbs - bdubbs@linuxfromscratch.org
 #
-# Version     : 00.00
-#
-# Notes       :
+# Version     : LFS 7.0
 #
 ########################################################################
 
-. /etc/sysconfig/rc
-. ${rc_functions}
+### BEGIN INIT INFO
+# Provides:            cleanfs
+# Required-Start:      $local_fs
+# Should-Start:
+# Required-Stop:
+# Should-Stop:
+# Default-Start:       S
+# Default-Stop:
+# Short-Description:   Cleans temporary directories early in the boot process.
+# Description:         Cleans temporary directories /var/run, /var/lock, and
+#                      optionally) /tmp.  cleanfs also creates /var/run/utmp 
+#                      and any files defined in /etc/sysconfig/createfiles.
+# X-LFS-Provided-By:   LFS
+### END INIT INFO
+
+. /lib/boot/functions
 
 # Function to create files/directory on boot.
@@ -22,5 +35,4 @@
 		while read name type perm usr grp dtype maj min junk
 		do
-
 			# Ignore comments and blank lines.
        			case "${name}" in
@@ -74,8 +86,9 @@
 		boot_mesg -n "Cleaning file systems:" ${INFO}
 
-		boot_mesg -n " /tmp" ${NORMAL}
-		cd /tmp &&
-		find . -xdev -mindepth 1 ! -name lost+found \
-			-delete || failed=1
+      if [ "${SKIPTMPCLEAN}" = "" ]; then
+		   boot_mesg -n " /tmp" ${NORMAL}
+		   cd /tmp &&
+		   find . -xdev -mindepth 1 ! -name lost+found -delete || failed=1
+      fi
 
 		> /var/run/utmp
@@ -101,3 +114,3 @@
 esac
 
-# End $rc_base/init.d/cleanfs
+# End cleanfs
Index: bootscripts/lfs/init.d/console
===================================================================
--- bootscripts/lfs/init.d/console	(revision 43c2ecf0b898e8dfaca243df6946522b5d49cda5)
+++ bootscripts/lfs/init.d/console	(revision 0cda8984a835f37a573c0e2eb31676ff52773d16)
@@ -1,30 +1,41 @@
 #!/bin/sh
 ########################################################################
-# Begin $rc_base/init.d/console
+# Begin console
 #
 # Description : Sets keymap and screen font
 #
 # Authors     : Gerard Beekmans - gerard@linuxfromscratch.org
-#		Alexander E. Patrakov
+#               Alexander E. Patrakov
+# Update      : Bruce Dubbs - bdubbs@linuxfromscratch.org
 #
-# Version     : 00.03
-#
-# Notes       :
+# Version     : LFS 7.0
 #
 ########################################################################
 
-. /etc/sysconfig/rc
-. ${rc_functions}
+. /lib/boot/functions
+
+### BEGIN INIT INFO
+# Provides:            console
+# Required-Start:
+# Should-Start:        $local_fs
+# Required-Stop:
+# Should-Stop:
+# Default-Start:       S
+# Default-Stop:
+# Short-Description:   Sets up a localised console.
+# Description:         Sets up fonts and language settings for the user's
+#                      local as defined by /etc/sysconfig/console.
+# X-LFS-Provided-By:   LFS
+### END INIT INFO
 
 # Native English speakers probably don't have /etc/sysconfig/console at all
-if [ -f /etc/sysconfig/console ]
-then
-	. /etc/sysconfig/console
+if [ -r /etc/sysconfig/console ]; then
+   . /etc/sysconfig/console
 else
-        exit 0
+   exit 0
 fi
 
 is_true() {
-	[ "$1" = "1" ] || [ "$1" = "yes" ] || [ "$1" = "true" ]
+   [ "$1" = "1" ] || [ "$1" = "yes" ] || [ "$1" = "true" ]
 }
 
@@ -32,65 +43,65 @@
 
 case "${1}" in
-	start)
-		boot_mesg "Setting up Linux console..."
-		# There should be no bogus failures below this line!
-		
-		# Figure out if a framebuffer console is used
-		[ -d /sys/class/graphics/fb0 ] && USE_FB=1 || USE_FB=0
-		
-		# Figure out the command to set the console into the
-		# desired mode
-		is_true "${UNICODE}" &&
-			MODE_COMMAND="${ECHO} -en '\033%G' && kbd_mode -u" ||
-			MODE_COMMAND="${ECHO} -en '\033%@\033(K' && kbd_mode -a"
-		
-		# On framebuffer consoles, font has to be set for each vt in
-		# UTF-8 mode. This doesn't hurt in non-UTF-8 mode also.
-		
-		! is_true "${USE_FB}" || [ -z "${FONT}" ] ||
-			MODE_COMMAND="${MODE_COMMAND} && setfont ${FONT}"
+   start)
+      boot_mesg "Setting up Linux console..."
+      # There should be no bogus failures below this line!
 
-		# Apply that command to all consoles mentioned in
-		# /etc/inittab. Important: in the UTF-8 mode this should
-		# happen before setfont, otherwise a kernel bug will
-		# show up and the unicode map of the font will not be
-		# used.
-		# FIXME: Fedora Core also initializes two spare consoles
-		# - do we want that?
-		
-		for TTY in `grep '^[^#].*respawn:/sbin/agetty' /etc/inittab |
-			grep -o '\btty[[:digit:]]*\b'`
-		do
-			openvt -f -w -c ${TTY#tty} -- \
-				/bin/sh -c "${MODE_COMMAND}" || failed=1
-		done
+      # Figure out if a framebuffer console is used
+      [ -d /sys/class/graphics/fb0 ] && USE_FB=1 || USE_FB=0
 
-		# Set the font (if not already set above) and the keymap
-		is_true "${USE_FB}" || [ -z "${FONT}" ] ||
-			setfont $FONT ||
-			failed=1
-		[ -z "${KEYMAP}" ] ||
-			loadkeys ${KEYMAP} >/dev/null 2>&1 ||
-			failed=1
-		[ -z "${KEYMAP_CORRECTIONS}" ] ||
-			loadkeys ${KEYMAP_CORRECTIONS} >/dev/null 2>&1 ||
-			failed=1
+      # Figure out the command to set the console into the
+      # desired mode
+      is_true "${UNICODE}" &&
+         MODE_COMMAND="${ECHO} -en '\033%G' && kbd_mode -u" ||
+         MODE_COMMAND="${ECHO} -en '\033%@\033(K' && kbd_mode -a"
 
-		# Convert the keymap from $LEGACY_CHARSET to UTF-8
-		[ -z "$LEGACY_CHARSET" ] ||
-			dumpkeys -c "$LEGACY_CHARSET" |
-			loadkeys -u >/dev/null 2>&1 ||
-			failed=1
+      # On framebuffer consoles, font has to be set for each vt in
+      # UTF-8 mode. This doesn't hurt in non-UTF-8 mode also.
 
-		# If any of the commands above failed, the trap at the
-		# top would set $failed to 1
-		( exit $failed )
-		evaluate_retval
-		;;
-	*)
-		echo $"Usage:" "${0} {start}"
-		exit 1
-		;;
+      ! is_true "${USE_FB}" || [ -z "${FONT}" ] ||
+         MODE_COMMAND="${MODE_COMMAND} && setfont ${FONT}"
+
+      # Apply that command to all consoles mentioned in
+      # /etc/inittab. Important: in the UTF-8 mode this should
+      # happen before setfont, otherwise a kernel bug will
+      # show up and the unicode map of the font will not be
+      # used.
+      # FIXME: Fedora Core also initializes two spare consoles
+      # - do we want that?
+
+      for TTY in `grep '^[^#].*respawn:/sbin/agetty' /etc/inittab |
+         grep -o '\btty[[:digit:]]*\b'`
+      do
+         openvt -f -w -c ${TTY#tty} -- \
+            /bin/sh -c "${MODE_COMMAND}" || failed=1
+      done
+
+      # Set the font (if not already set above) and the keymap
+      is_true "${USE_FB}" || [ -z "${FONT}" ] ||
+         setfont $FONT ||
+         failed=1
+      [ -z "${KEYMAP}" ] ||
+         loadkeys ${KEYMAP} >/dev/null 2>&1 ||
+         failed=1
+      [ -z "${KEYMAP_CORRECTIONS}" ] ||
+         loadkeys ${KEYMAP_CORRECTIONS} >/dev/null 2>&1 ||
+         failed=1
+
+      # Convert the keymap from $LEGACY_CHARSET to UTF-8
+      [ -z "$LEGACY_CHARSET" ] ||
+         dumpkeys -c "$LEGACY_CHARSET" |
+         loadkeys -u >/dev/null 2>&1 ||
+         failed=1
+
+      # If any of the commands above failed, the trap at the
+      # top would set $failed to 1
+      ( exit $failed )
+      evaluate_retval
+      ;;
+   *)
+      echo $"Usage:" "${0} {start}"
+      exit 1
+      ;;
 esac
 
-# End $rc_base/init.d/console
+# End console
